#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Oct 25 10:39:36 2018

@author: melot
"""

import numpy as np
#import numpy.fft as npfft
import numpy.linalg as npl

from scipy.fftpack import dct,idct
import matplotlib.pyplot as plt

def creatematrixCaDct(N):
    """Crée la matrice d'un dictionnaire D de taille 2N*N qui est la concaténation 
    de la base canonique et de la base de DCT orthonormale

    Entrée :

    N -- taille des bases considérées

    Sortie:
        
    D -- matrice du dictionnaire.

    """
    F=np.zeros((N,N))
    for i in np.arange(0,N):
        u=np.zeros(N)
        u[i]=1
        e=idct(u,norm='ortho')
        
        #e=np.reshape(e,(N,))
        F[:,i]=e
    #D=F    
    D=np.concatenate((np.eye(N),F),axis=1)
    return D

D=creatematrixCaDct(16)

print(npl.norm(np.dot(D,D.T),2))

